/* GLUES constants definition; this file is part of
   the Global Land Use and technological Evolution Simulator
   
   Copyright (C) 2007
   Carsten Lemmen <carsten.lemmen@gkss.de>, Kai Wirtz <kai.wirtz@gkss.de>

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any later
   version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
   Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
*/
/**
   @author Carsten Lemmen <carsten.lemmen@gkss.de>
   @author Kai W Wirtz <kai.wirtz@gkss.de
   @date   2008-01-08
   @file Constants.h
   @brief Definition of constants
*/
#ifndef glues_constants_h
#define glues_constants_h

#include "Symbols.h"

#define N_INSPECT 12
#define N_POPVARS 6
#define N_OUTVARS 12
#define MIN_NPP 1.0
#define N_VARIAT 16
#define DIMW2 720  /* half degree lon world */
#define DIMW1 360  /* half degree lat world */
#define MAXPROXY 12

//namespace glues {

#define KeyCMexico 410 
#define KeyFCrescent 271

//}

#endif /* glues_constants_h */
