function cl_calc_regionpath

cl_register_function();

%dir='/h/lemmen/projects/glues/glues/glues/examples/setup/686';
%map=fullfile(dir,'mapping_80_686.mat');

% Need mapping file enriched with sea information by calc_seas.m
mapfile='regionmap_sea_685.mat';
%map='regionmap.mat';

if ~exist(mapfile,'file')
  fprintf('Please create file regionmap_sea_XXX.mat first by running cl_calc_seas\n');
  return
end

debug=4

%map='$HOME/projects/glues/glues/glues/setup/mapping_80_686.mat'

load(mapfile);

[rows,cols]=size(map.region);
if rows>cols
  map.region=map.region';
 [rows,cols]=size(map.region);
end 


nland=length(land.map);
nreg=length(region.length);

region.path=zeros(nreg,400,3)-NaN;
region.neighbourhood=zeros(nreg,100)-NaN;

%[land.ilat,land.ilon]=regidx2geoidx(land.map,cols);
[ilat,ilon]=cl_i2lli(land.map,cols);

% fix reversed latgrid, it should be decreasing from 90.. -90
if (map.latgrid(1)==-89.75) 
  map.latgrid=fliplr(map.latgrid);
end

%% land.lat and land.lon are good, thus recreate everything else, i.e.
%  recreate map.region,land.map
lat=land.lat;
lon=land.lon;
map.resolution=abs([map.latgrid(1)-map.latgrid(2),map.longrid(1)-map.longrid(2)]);

land.ilat=rows+1-ceil((land.lat+map.resolution(1)/2-min(map.latgrid))/map.resolution(1));
land.ilon=ceil((land.lon+map.resolution(2)/2-min(map.longrid))/map.resolution(2));
land.map=cl_lli2i(land.ilat,land.ilon);
map.region=map.region*0-10;
map.region(land.map)=land.region;

% Sanity check for ilon/ilat
ok=all(map.latgrid(land.ilat)==land.lat').*all(map.longrid(land.ilon)==land.lon')


f=find(land.region==272);
fl=land.lat(f);
fm=map.latgrid(land.ilat(f));



border=zeros(nland,4);

ilon=land.ilon;
ilat=land.ilat;

ilonl=ilon-1;
ilonl(ilonl==0)=cols;
ilonr=ilon+1;
ilonr(ilonr==cols+1)=1;

nnu=cl_lli2i(ilat-1,ilon,cols);
nnd=cl_lli2i(ilat+1,ilon,cols);
nnl=cl_lli2i(ilat,ilonl,cols);
nnr=cl_lli2i(ilat,ilonr,cols);
nni=cl_lli2i(ilat,ilon,cols);


ok=all(map.region(nni)==land.region)

border=[map.region(nnl)~=land.region, map.region(nnu)~=land.region, ...
  map.region(nnr)~=land.region, map.region(nnd)~=land.region];

% border is size (nland,4)
nborder=sum(border,2);
iborder=find(nborder > 0);
nborderland=length(iborder);

debug=4;
 
latgrid=map.latgrid;
longrid=map.longrid;

if ~isfield(region,'center')
  region.center=zeros(nreg,2);
  for ireg=1:nreg
    me=ireg;
  
    % select all cells of this region
    iselect=find(land.region == ireg);
    nselect=length(iselect);
    if nselect<1 error('Region with zero grid cells'); end
    if nselect~=region.length(ireg) error('Inconsistency detected'); end

   region.center(ireg,1)=calc_geo_mean(map.latgrid(ilat(iselect)),map.longrid(ilon(iselect)));
   region.center(ireg,2)=mean(map.latgrid(ilat(iselect)));

  if debug>2

    colors='rgyb';
    latmin=max([-90,min(latgrid(ilat(iselect)))-1]);
  latmax=min([ 90,max(latgrid(ilat(iselect)))+1]);
  lonmin=max([-180,min(longrid(ilon(iselect)))-2]);
  lonmax=min([ 180,max(longrid(ilon(iselect)))+2]);
  figure(1); clf reset;
  title=sprintf('Regions');
  m_proj('miller','lat',[latmin latmax],'lon',[lonmin, lonmax]);
  m_coast('line','color','k');
  m_grid;
  hold on;
    m_line(land.lon(iselect),land.lat(iselect),'color','b','Linestyle','none','marker','o');
    m_plot(region.center(ireg,1),region.center(ireg,2),'k*');
    for ib=1:4
      is=border(iselect,ib)==1;
      if ~isempty(is)
      m_plot(land.lon(iselect(is)),land.lat(iselect(is)),'y.','color',colors(ib)); end
    end
    %m_line(land.lon(ilon(border(:,1)==1)),land.lat(ilat(border(:,1)==1),'color','y','Linestyle','none','marker','.');
    %m_plot(region.lon(ireg),region.lat(ireg),'ro');
  end
  end
  save(mapfile,'map','land','region');
end

  
for ireg=1:nreg %:nreg 
%    for ireg=400:400
  me=ireg;  
  % select all cells of this region
  iselect=find(land.region == ireg);
  nselect=length(iselect);
  rborder=border(iselect,:);
  if nselect<1 
     fprintf('Something is wrong here, no cells with region id %d\n',me);
     continue; 
  end
  
  latmin=max([-90,min(latgrid(ilat(iselect)))-1]);
  latmax=min([ 90,max(latgrid(ilat(iselect)))+1]);
  lonmin=max([-180,min(longrid(ilon(iselect)))-2]);
  lonmax=min([ 180,max(longrid(ilon(iselect)))+2]);

  region.area(ireg)=sum(calc_gridcell_area(latgrid(ilat(iselect))));

    
  if debug>0
    figure(1); clf reset;
    title=sprintf('Region %d',ireg);
    m_proj('Miller','lon',[lonmin lonmax],'lat',[latmin latmax]);
    m_coast('line','color','k');
    m_grid;
    m_line(lon(iselect),lat(iselect),'color','y','Linestyle','none','marker','.');
    hold on;
    m_plot(region.center(ireg,1),region.center(ireg,2),'ks');
    
    ilo=find(longrid>lonmin & longrid<lonmax);
    ila=find(latgrid>latmin & latgrid<latmax);
    nla=length(ila);
    nlo=length(ilo);
    lo=repmat(longrid(ilo)',1,nla);
    la=repmat(latgrid(ila),nlo,1);
   % if (nreg==685 || nreg==686) ilat=361-ilat; end
    m_text(reshape(lo,nlo*nla,1),reshape(la,nlo*nla,1),...
        num2str(reshape(map.region(ila,ilo),nlo*nla,1)),...
        'VerticalAlignment','middle','HorizontalAlignment','center','FontSize',6);
    
  end


  % select all border cells of this region
  iselect=find(land.region == ireg & nborder > 0);
  rborder=border(iselect,:);
  nselect=length(iselect);
  if nselect<1 
      fprintf('Something is wrong here, no border cells with region id %d\n',me);
     continue;  
  end

    
  if debug>0
      m_line(land.lon(iselect),land.lat(iselect),'color','b','Linestyle','none','marker','.');
  end
  % calculate neighbourhood to the left,top,right, and bottom 
  neighbours=[];
  ileft=find(land.region == ireg &  border(:,1) );
  neighbours=[neighbours; map.region(nnl(ileft))];
  if ~isempty(ileft) & debug 
        m_text(lon(ileft),lat(ileft),num2str(map.region(nnl(ileft))),...
            'color','r','HorizontalAlignment','right','FontSize',6);
  end

  itop=find(land.region == ireg &  border(:,2) );
  neighbours=[neighbours; map.region(nnu(itop))];
  if ~isempty(itop) & debug 
        m_text(lon(itop),lat(itop),num2str(map.region(nnu(itop))),...
            'color','b','VerticalAlignment','bottom','FontSize',6);
  end

  iright=find(land.region == ireg &  border(:,3) );
  neighbours=[neighbours; map.region(nnr(iright))];
  if ~isempty(iright) & debug 
        m_text(lon(iright),lat(iright),num2str(map.region(nnr(iright))),...
            'color','g','HorizontalAlignment','left','FontSize',6);
  end

  ibot=find(land.region == ireg &  border(:,4) );
  neighbours=[neighbours; map.region(nnd(ibot))];
  if ~isempty(ibot) & debug 
        m_text(lon(ibot),lat(ibot),num2str(map.region(nnd(ibot))),...
            'color','m','VerticalAlignment','top','HorizontalAlignment','Center','FontSize',6);
  end

  neighbours=unique(neighbours);
  neighbours=neighbours(find(neighbours ~= me));
  region.neighbours(ireg)=length(neighbours);
  region.neighbourhood(ireg,1:region.neighbours(ireg))=neighbours';
  
  % calculate outline
  npath=sum(sum(border(iselect,:)));
  path=zeros(npath+1,3)+NaN;

  isel=randi(nselect);
  ipath=1; 
  idir=0;
  pathoffset=0;
  while(sum(sum(rborder(:,:))) > 0)
    %fprintf('%d\n',sum(sum(border(iselect,:))));

    iss=iselect(isel);
    latc=lat(iss);
    lonc=lon(iss);
    iloc=ilon(iss);
    ilac=ilat(iss);
    ilol=ilonl(iss);
    ilor=ilonr(iss);
    lonc=map.longrid(iloc);
    lonl=map.longrid(ilol);
    lonr=map.longrid(ilor);
    latc=map.latgrid(ilac);
    latu=map.latgrid(ilac-1);
    latl=map.latgrid(ilac+1);
    
    isort=mod([0:3]+idir,4)+1;
    %ibord=find((border(iselect(isel),isort)));
    ibord=find(rborder(isel,isort));
    if isempty(ibord)
        break;
        % This happens when a region is not contiguous
        path(ipath,:)=path(1+pathoffset,:); % close prior ring
        path(ipath+1,:)=[NaN,NaN,NaN]; % create break in path
        ipath=ipath+2;
        pathoffset=ipath;
        ifsel=find(sum(rborder,2)>0);
        isel=ifsel(randi(length(ifsel)));
        continue;
    end
    ibord=ibord(1);
    switch isort(ibord)
      case 1
        path(ipath,:)=[lonc-0.25,latc,map.region(ilac,ilol)];
        if (map.region(ilac-1,ilol) == me) idir=3; ineigh=1;
        elseif (map.region(ilac-1,iloc) == me) idir=0; ineigh=2;
        else ineigh=8; idir=1; end
        if 0&ipath>1 & path(ipath-1,3)~=path(ipath,3)
           path(ipath+1,:)=path(ipath,:);
           path(ipath,:)=[lonc-0.25,latc-0.25,NaN];
           ipath=ipath+1;
        end
        
      case 2
        path(ipath,:)=[lonc,latc+0.25,map.region(ilac-1,iloc)];
        if (map.region(ilac-1,ilor) == me) idir=0; ineigh=3; 
        elseif (map.region(ilac,ilor) == me) idir=1; ineigh=4; 
        else idir=2; ineigh=8; end
        if 0&ipath>1 & path(ipath-1,3)~=path(ipath,3)
           path(ipath+1,:)=path(ipath,:);
           path(ipath,:)=[lonc-0.25,latc+0.25,NaN];
           ipath=ipath+1;
        end
      case 3
        path(ipath,:)=[lonc+0.25,latc,map.region(ilac,ilor)];
        if (map.region(ilac+1,ilor) == me) idir=1; ineigh=5;
        elseif (map.region(ilac+1,iloc) == me) idir=2; ineigh=6; 
        else idir=3; ineigh=8; end
        if 0&ipath>1 & path(ipath-1,3)~=path(ipath,3)
           path(ipath+1,:)=path(ipath,:);
           path(ipath,:)=[lonc+0.25,latc+0.25,NaN];
           ipath=ipath+1;
        end
      case 4
        path(ipath,:)=[lonc,latc-0.25,map.region(ilac+1,iloc)];
        if (map.region(ilac+1,ilol) == me) idir=2; ineigh=7; 
        elseif (map.region(ilac,ilol) == me)  idir=3; ineigh=0; 
        else  idir=0; ineigh=8; end
        if ipath>1 & path(ipath-1,3)~=path(ipath,3)
           path(ipath+1,:)=path(ipath,:);
           path(ipath,:)=[lonc+0.25,latc-0.25,NaN];
           ipath=ipath+1;
        end
    end
 if debug>0
    m_line(path(1:ipath,1),path(1:ipath,2),'color','r','marker','.');
 end
    ipath=ipath+1;
    %border(iselect(isel),isort(ibord))=0;
    rborder(isel,isort(ibord))=0;
    if debug fprintf('%d %d %f=%f %f=%f\n',isel,ineigh,latc,lat(iselect(isel)),lonc,lon(iselect(isel)));
    end

     switch ineigh 
       case 0, isel=find(lat(iselect) == latc & lon(iselect) == lonl);
       case 1, isel=find(lat(iselect) == latu & lon(iselect) == lonl);
       case 2, isel=find(lat(iselect) == latu & lon(iselect) == lonc);
       case 3, isel=find(lat(iselect) == latu & lon(iselect) == lonr);
       case 4, isel=find(lat(iselect) == latc & lon(iselect) == lonr);
       case 5, isel=find(lat(iselect) == latl & lon(iselect) == lonr);
       case 6, isel=find(lat(iselect) == latl & lon(iselect) == lonc);
       case 7, isel=find(lat(iselect) == latl & lon(iselect) == lonl);
       case 8, isel=isel ; find(lat(iselect) == latc & lon(iselect) == lonc);
      end
     
   
   
    %if isempty(isel)
     %  fprintf('%d %f=%f %f?%f?\n',isel,latc,lat(iselect(isel)),lonc,lon(iselect(isel)));
       %end
  end
  
  %fprintf('%d %d\n',npath,ipath);

  path(ipath,:)=path(1+pathoffset,:);
  %m_line(path(1:ipath,1),path(1:ipath,2),'color','b');
  region.path(ireg,1:ipath,1)=path(1:ipath,1);
  region.path(ireg,1:ipath,2)=path(1:ipath,2);
  region.path(ireg,1:ipath,3)=path(1:ipath,3);
  if debug m_plot(region.path(ireg,:,1),region.path(ireg,:,2),'m-','LineW',4); end
  %Consistency check
  
  upath=unique(region.path(ireg,1:ipath,3));
  upath=upath(isfinite(upath));
  uneigh=region.neighbourhood(ireg,1:region.neighbours(ireg));
  if (length(upath)~=length(uneigh)) 
      warning('Inconsistency in path and neighbours for region %d',ireg);
  end
  
  
  warning('The path contains still too many nans, something needs to be fixed in this routine');
  error('Do not use this routine right now');
  
  if mod(ireg,20)==0 fprintf('.'); end
  
  
end

%regioncenter=zeros(nreg,2)-NaN;
%for ireg=1:nreg
%  iselect=find(regionnumber == ireg);
%  regioncenter(ireg,:)=[mean(lat(iselect)),mean(lon(iselect))];
%end

longest_path=max(find(isfinite(min(region.path(:,:,1)))));
most_neighbours=max(find(isfinite(min(region.neighbourhood(:,:)))));
region.path=region.path(:,[1:longest_path],:);
region.neighbourhood=region.neighbourhood(:,[1:most_neighbours]);

% regionneighbours: number of neighbours size (nreg,1)
% regioncenter:     lat lon of central point (nreg,2)
% regionpath:       lat lon neighid of path (nreg,maxpathlength,3)    

regionpathfile=sprintf('regionpath_%d.mat',nreg);

region.nreg=nreg;

save('-v6',regionpathfile,'region','map');

return;
